Attribute VB_Name = "RegionFromBitmap"
'*******************************************************************************************
'*******************************************************************************************
'Pour info, ce module source vient du site http://www.activevb.de/tipps/vb6tipps/tipp0470.html
'Il peut tre utilis librement
'Les modifications que j'ai effectus  ce module sont:
'Compatibilit pour Win98
'Qq commentaires en fr
'Dsactivation d'APIs et procdures que je n'utilise pas dans mon programme
'Ajout ou modif. dans le code : '**Ajout ou Modif au code origine
'*******************************************************************************************
'*******************************************************************************************
'
'*****************************************
'********Module couleur invisible*********
'*****************************************
'
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

'Code von Benjamin Wilger
'Benjamin@ActiveVB.de
'Copyright (C) 2001

Option Explicit

Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
'**Dsactivation API - Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Const RGN_OR As Long = 2&

'**Dsactivation API - Private Declare Sub OleTranslateColor Lib "oleaut32.dll" ( _
'**     ByVal clr As Long, _
'**     ByVal hpal As Long, _
'**     ByRef lpcolorref As Long)

Private Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As RGBQUAD
End Type

Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function CreateDIBSection Lib "gdi32" (ByVal hDC As Long, pBitmapInfo As BITMAPINFO, ByVal un As Long, ByVal lplpVoid As Long, ByVal handle As Long, ByVal dw As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long

Private Const BI_RGB As Long = 0&
Private Const DIB_RGB_COLORS As Long = 0&

'**Dsactivation API - Private Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
'**Dsactivation API - Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
'**Dsactivation API - Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
'**Dsactivation API - Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long

'**Dsactivation API - Private Const LWA_COLORKEY As Long = &H1&
'**Dsactivation API - Private Const GWL_EXSTYLE As Long = (-20&)
'**Dsactivation API - Private Const WS_EX_LAYERED As Long = &H80000

'**Dsactivation API - Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
'**Dsactivation API - Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
'**Dsactivation API - Private Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal hWnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long



'**=>**Dsactivation - procdure********************************************************
'**Public Function MakeFormTransparent(frm As Form, ByVal lngTransColor As Long)
'**Cette procdure fonctionne trs bien avec une Form sous win2000 et XP
'**Je ne suis pas arriv  l'adapter pour une PictureBox,
'**mme avec comme frn As Picture ou frn As Objet
'**Je pense avoir un problme avec WinStyle = WinStyle Or WS_EX_LAYERED
'**Si vous avez des ides, je suis preneur.
    
'**    Dim hRegion As Long
'**    Dim WinStyle As Long
    
'**Conversion des couleurs, systme - RGB
'**    'Systemfarben ggf. in RGB-Werte bersetzen
'**    If lngTransColor < 0 Then OleTranslateColor lngTransColor, 0&, lngTransColor

'**La procdure IsFunctionExported et l'API SetLayeredWindowAttributes
'**fonctionnent uniquement sous win2000 et XP
    
'**    'Ab Windows 2000/98 geht das relativ einfach per API
'**    'Mit IsFunctionExported wird geprft, ob die Funktion
'**    'SetLayeredWindowAttributes unter diesem Betriebsystem untersttzt wird.
    
'**    If IsFunctionExported("SetLayeredWindowAttributes", "user32") Then '**Pour Win2000 & XP
'**Place le style de fentre sur "des Layered"
'**        'Den Fenster-Stil auf "Layered" setzen
'**        WinStyle = GetWindowLong(frm.hWnd, GWL_EXSTYLE)
'**        WinStyle = WinStyle Or WS_EX_LAYERED
'**        SetWindowLong frm.hWnd, GWL_EXSTYLE, WinStyle
'**        SetLayeredWindowAttributes frm.hWnd, lngTransColor, 0&, LWA_COLORKEY
        
'**    Else 'Manuell die Region erstellen und bernehmen
'**Pour Win98, ME, mais fonctionne aussi sous Win2000 & XP
'**Appel la procdure de dcoupage en rgion transparente
'**        hRegion = RegionFromBitmap(frm, lngTransColor)
'**Application des rgions transparentes dans la form
'**        SetWindowRgn frm.hWnd, hRegion, True
'**        DeleteObject hRegion
'**    End If
'**End Function
'**=>*******************************************************************************

'**=>**Ajout nouvelle procdure au code origine*****************************************
Public Function Couleur_Invisible(PctBox_Image As Object, ByVal Couleur_Transparente As Long) As Long
Dim hRegion As Long
Dim Mem_AutoRedraw As Boolean
Dim Mem_ScaleMode As ScaleModeConstants

On Error Resume Next

'Mmorisation de l'unit de mesure (vbPixel, vbTwips, ...)
Mem_ScaleMode = PctBox_Image.ScaleMode
'Mmorisation de la mthode graphique
Mem_AutoRedraw = PctBox_Image.AutoRedraw

PctBox_Image.AutoRedraw = True
PctBox_Image.ScaleMode = vbPixels 'Mesure en pixels - chelle

'Appel la procdure de dcoupage en rgion transparente
hRegion = RegionFromBitmap(PctBox_Image, Couleur_Transparente)

'Application des rgions transparentes dans la PictureBox
Call SetWindowRgn(PctBox_Image.hWnd, hRegion, True)

'Nettoyage objet
Call DeleteObject(hRegion)

PctBox_Image.ScaleMode = Mem_ScaleMode
''PctBox_Image.Refresh 'Actualise notre image
PctBox_Image.AutoRedraw = Mem_AutoRedraw
End Function
'**=>**Fin******************************************************************************

Private Function RegionFromBitmap(picSource As Object, ByVal lngTransColor As Long) As Long
'**Procdure de dcoupage en rgion transparente,
'via un tableau de bytes  2 dimensions avec GetDIBits
'L'utilisation de GetDIBits avec un dcoupage en rgion transparente
'est plus rapide que si l'on utilise les APIs Get/SetPixel

    Dim lngRetr As Long, lngHeight As Long, lngWidth As Long
    Dim lngRgnFinal As Long, lngRgnTmp As Long
    Dim lngStart As Long
    Dim X As Long, Y As Long
    Dim hDC As Long
    
    Dim bi24BitInfo As BITMAPINFO
    Dim iBitmap As Long
    Dim BWidth As Long
    Dim BHeight As Long
    Dim iDC As Long
    Dim PicBits() As Byte

'**    Dim Col As Long
'**    Dim OldScaleMode As ScaleModeConstants

'**    OldScaleMode = picSource.ScaleMode
'**    picSource.ScaleMode = vbPixels
   
On Error Resume Next
   
    hDC = picSource.hDC
    lngWidth = picSource.ScaleWidth '- 1
    lngHeight = picSource.ScaleHeight - 1

    BWidth = (picSource.ScaleWidth \ 4) * 4 + 4
    BHeight = picSource.ScaleHeight

'**bitmap - les enttes
    'Bitmap-Header
    With bi24BitInfo.bmiHeader
        .biBitCount = 24
        .biCompression = BI_RGB
        .biPlanes = 1
        .biSize = Len(bi24BitInfo.bmiHeader)
        .biWidth = BWidth
        .biHeight = BHeight + 1
    End With

'**Redimensionne le tableau de bytes (2 dimensions) au format de l'image
    'ByteArrays in der erforderlichen Gre anlegen
    ReDim PicBits(0 To bi24BitInfo.bmiHeader.biWidth * 3 - 1, 0 To bi24BitInfo.bmiHeader.biHeight - 1)
'**Cre une zone graphique DC
    iDC = CreateCompatibleDC(hDC)
    'Gertekontextunabhngige Bitmap (DIB) erzeugen
'**Cre une section DiBits DC
    iBitmap = CreateDIBSection(iDC, bi24BitInfo, DIB_RGB_COLORS, ByVal 0&, ByVal 0&, ByVal 0&)
    'iBitmap in den neuen DIB-DC whlen
    'Call SelectObject(iDC, iBitmap)
Call DeleteObject(SelectObject(iDC, iBitmap)) '**Modif., au code origine

'**On copie l'image source dans notre conteneur temporaire
    'hDC des Quell-Fensters in den hDC der DIB kopieren
    Call BitBlt(iDC, 0, 0, bi24BitInfo.bmiHeader.biWidth, bi24BitInfo.bmiHeader.biHeight, hDC, 0, 0, vbSrcCopy)
'**On rcupre notre image dans un tableau de bytes  2 dimensions - PicBits(0, 0)
    'Gertekontextunabhngige Bitmap in ByteArrays kopieren
    Call GetDIBits(hDC, iBitmap, 0, bi24BitInfo.bmiHeader.biHeight, PicBits(0, 0), bi24BitInfo, DIB_RGB_COLORS)
    'Wir brauchen nur den Array, also knnen wir die Bitmap direkt wieder lschen.

'**Nettoyage
    'DIB-DC
    'Call DeleteDC(iDC)
    'Bitmap
    'Call DeleteObject(iBitmap)
'**Modif. au code origine
Call DeleteObject(iBitmap)
Call DeleteDC(iDC)
Call DeleteObject(iBitmap)
Call DeleteDC(iDC)

'**Maintenant on va parcourir notre tableau de bytes,
'**pour enregistrer le dcoupage en rgion transparente
    lngRgnFinal = CreateRectRgn(0, 0, 0, 0)
    For Y = 0 To lngHeight
        X = 0
        Do While X < lngWidth
            Do While X < lngWidth And _
                RGB(PicBits(X * 3 + 2, lngHeight - Y + 1), _
                    PicBits(X * 3 + 1, lngHeight - Y + 1), _
                    PicBits(X * 3, lngHeight - Y + 1) _
                    ) = lngTransColor
                
                X = X + 1
            Loop
            If X <= lngWidth Then
                lngStart = X
                Do While X < lngWidth And _
                    RGB(PicBits(X * 3 + 2, lngHeight - Y + 1), _
                        PicBits(X * 3 + 1, lngHeight - Y + 1), _
                        PicBits(X * 3, lngHeight - Y + 1) _
                        ) <> lngTransColor
                    X = X + 1
                Loop
                If X + 1 > lngWidth Then X = lngWidth
                lngRgnTmp = CreateRectRgn(lngStart, Y, X, Y + 1)
'**Enregistrement du dcoupage dans lngRgnFinal
                lngRetr = CombineRgn(lngRgnFinal, lngRgnFinal, lngRgnTmp, RGN_OR)
                Call DeleteObject(lngRgnTmp)
                Call DeleteObject(lngRgnTmp)
            End If
        Loop
    Next

'**Ajout au code origine
Erase PicBits '**Libre la mmoire utilise
    
'**    picSource.ScaleMode = OldScaleMode
    RegionFromBitmap = lngRgnFinal

End Function

'**=>**Dsactivation - procdure********************************************************
'**'Code von vbVision:
'**'Diese Funktion berprft, ob die angegebene Function von einer DLL exportiert wird.
'**=>**Private Function IsFunctionExported(ByVal sFunction As String, ByVal sModule As String) As Boolean
'**Procdure qui examine, si la Dll indiqu et est export
'**    Dim hMod As Long, lpFunc As Long, bLibLoaded As Boolean

'**Handle de la DLL
'**    'Handle der DLL erhalten
'**    hMod = GetModuleHandle(sModule)
'**    If hMod = 0 Then 'Falls DLL nicht registriert ...
'**Echec, la Dll n'est pas enregistr
'**Chargement de la DLL dans la mmoire
'**        hMod = LoadLibrary(sModule) 'DLL in den Speicher laden.
'**        If hMod Then bLibLoaded = True
'**    End If
    
'**    If hMod Then
'**        If GetProcAddress(hMod, sFunction) Then IsFunctionExported = True
'**    End If
    
'**    If bLibLoaded Then Call FreeLibrary(hMod)
'**=>**End Function
'*******************************************************************************
